﻿// <auto-generated />
using System;
using Axel.MiniBicks.Data;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace Axel.MiniBicks.Data.Migrations
{
    [DbContext(typeof(BickContext))]
    [Migration("20191122102404_InitialCreate")]
    partial class InitialCreate
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.0.1");

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.Absence", b =>
                {
                    b.Property<int>("AbsenceId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("INTEGER");

                    b.Property<string>("Libelle")
                        .HasColumnType("TEXT");

                    b.HasKey("AbsenceId");

                    b.ToTable("Absences");
                });

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.AbsenceUser", b =>
                {
                    b.Property<int>("AbsenceUserId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("INTEGER");

                    b.Property<int>("AbsenceId")
                        .HasColumnType("INTEGER");

                    b.Property<DateTime>("DateDebut")
                        .HasColumnType("TEXT");

                    b.Property<DateTime>("DateFin")
                        .HasColumnType("TEXT");

                    b.Property<string>("Justificatif")
                        .HasColumnType("TEXT");

                    b.Property<int>("Userid")
                        .HasColumnType("INTEGER");

                    b.HasKey("AbsenceUserId");

                    b.HasIndex("AbsenceId");

                    b.HasIndex("Userid");

                    b.ToTable("AbsenceUsers");
                });

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.Remboursement", b =>
                {
                    b.Property<int>("RemboursementId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("INTEGER");

                    b.Property<string>("Libelle")
                        .HasColumnType("TEXT");

                    b.HasKey("RemboursementId");

                    b.ToTable("Remboursements");
                });

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.RemboursementUser", b =>
                {
                    b.Property<int>("RemboursementUserId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("INTEGER");

                    b.Property<DateTime>("DateDebut")
                        .HasColumnType("TEXT");

                    b.Property<DateTime>("DateFin")
                        .HasColumnType("TEXT");

                    b.Property<string>("Justificatif")
                        .HasColumnType("TEXT");

                    b.Property<int>("RemboursementId")
                        .HasColumnType("INTEGER");

                    b.Property<int>("UserId")
                        .HasColumnType("INTEGER");

                    b.HasKey("RemboursementUserId");

                    b.HasIndex("RemboursementId");

                    b.HasIndex("UserId");

                    b.ToTable("RemboursementUsers");
                });

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.Role", b =>
                {
                    b.Property<int>("RoleId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("INTEGER");

                    b.Property<string>("Libelle")
                        .HasColumnType("TEXT");

                    b.HasKey("RoleId");

                    b.ToTable("Roles");
                });

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.User", b =>
                {
                    b.Property<int>("UserId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("INTEGER");

                    b.Property<string>("Address")
                        .HasColumnType("TEXT");

                    b.Property<string>("FirstName")
                        .HasColumnType("TEXT");

                    b.Property<string>("LastName")
                        .HasColumnType("TEXT");

                    b.Property<int>("RoleId")
                        .HasColumnType("INTEGER");

                    b.Property<int>("SuperieurId")
                        .HasColumnType("INTEGER");

                    b.HasKey("UserId");

                    b.HasIndex("RoleId");

                    b.HasIndex("SuperieurId");

                    b.ToTable("Users");
                });

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.AbsenceUser", b =>
                {
                    b.HasOne("Axel.MiniBicks.Data.Models.Absence", "Absence")
                        .WithMany()
                        .HasForeignKey("AbsenceId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Axel.MiniBicks.Data.Models.User", "User")
                        .WithMany()
                        .HasForeignKey("Userid")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.RemboursementUser", b =>
                {
                    b.HasOne("Axel.MiniBicks.Data.Models.Remboursement", "Remboursement")
                        .WithMany()
                        .HasForeignKey("RemboursementId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Axel.MiniBicks.Data.Models.User", "User")
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Axel.MiniBicks.Data.Models.User", b =>
                {
                    b.HasOne("Axel.MiniBicks.Data.Models.Role", "Role")
                        .WithMany()
                        .HasForeignKey("RoleId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Axel.MiniBicks.Data.Models.User", "Superieur")
                        .WithMany()
                        .HasForeignKey("SuperieurId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
